/*
 * rds - random dot stereogram
 *
 * 1993-05-23 Written by Kouichi Hirabayashi
 */

#if 0
	Ե§ͤʿԻ뤹ȡΩο޷⤫Ӿ夬ȤRandom 
Dot StereogramפϡȤƤ򤤤ΤΤҤȤĤǤ顢ץץ
ä뤳Ȥˤޤɥåȡ᡼νϤϡ640x400 ɥåȤ 2 Ͳ
J-3100 ͭɽˤʤäƤޤΤǡ¾Υϡɥξϡñ
ܿɬפǤޤ꡼Υɥåȴֳ֤Υڥϡ1:1 Ȥ
ǽ񤫤Ƥޤ޷ΤΤϡ椬Ǥ⤫ޤʤ褦ʤΤ
ޤ

[1] 饤󡦥ޥ˥奢

ޥ	rds - ࡦɥåȡƥ쥪
ʸ	rds [-s] [ե]
ե饰	-s	ƤʥɥåȡХѤޤ
	rds		# RDS ᡼ɽ
	rds >file	# RDS ᡼ file ˳Ǽ
	rds file	# file ˳Ǽ줿 RDS ᡼ɽ
	rds ϥࡦɥåȡƥ쥪ȸƤФ롢Ե§ͤط
ˤΩץǤ꡼ɽ줿ʿԻ뤹뤳
ˤꡢΩδΤ޷ޤե뤬ꤵ뤫ɸϤ
쥯Ȥ줿ϡäƥե˳Ǽ줿 RDS ᡼ɽޤ
ɸϤ쥯Ȥ줿ϡ RDS ᡼ꤵ줿ե
˳Ǽޤ

[2] ܿ

	¾ε˰ܿϡդƤ

1) DOTX, DOTY 

	VRAM ̤ X  Y Υɥåȡʥԥ˿Ǥѹ
ϡvram[] 礭ѹɬפ뤫⤷ޤ

2) wrt_vram()

	wrt_vram[] Υɥåȡ᡼ǥץ쥤ɽ롼Ǥ
Ƭˡ1 ӥå 1 ɥåȤ 2 ͥ饹᡼ɽ
ɤΤǤȥåסӥåȤ¦ˤʤޤ

3) get_offset()

	ϡJ-3100 ܸǡפϡɥȤäƤ
ᡢߡ꡼ɽƤ VRAM Υȡɥ쥹뤿
ؿǤ¾Υϡɥξϡפˤʤ뤫񤭴ɬפȻפ
ޤ

[3] RDS θ

	̤ΰֺ¦ϡܤǸ뤿ΡܤȤʤࡦɥåȡ
ǤΤPITCHפǤϡξܤδֳ֤˶ᤤ
ˤɬפޤ鱦¦ˤĤƤϡطʤϡPITCHʬΩɽ
޷ˤĤƤϡPITCH - zפ¦Υѥ缡ԡƤ椭ޤ
z طʤοľεΥǤz ˤСطʤ˸뤳
ˤʤޤ

	ΥץǤϡĤʿ̤ȤäƤޤ󤬡߿Τ褦
Ϣ³̤ޤޤɽ޷׻ǵˡäƺäƤ
ӥåȥ᡼ο޷Ȥ褦ˤȡäȼͳʳޤ

[4] ʿԻ

	ץ롦ץ s14.c ˡμΩο޷򸫤뤿
ˡޤ
#endif

#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv);
void usage(void);
void error(char *s, char *t);
void backgnd(void);
void rds(void);
void wrt_vram(void);
void wrt_vram(void);

/* size of screen */
#define DOTX	640
#define DOTY	456

/* width of random dot */
#define PITCH	120

/* parameters for figure */
#define	RADIUS	80
#define DEPTH	5

char vram[(DOTX/8)*DOTY];	/* VRAM image */

int sflg;		/* sparse dot pattern */
char *cmd;

main(argc, argv) char **argv;
{
  char *s;
  int fd = -1;

  cmd = argv[0];
  while (--argc > 0 && (*++argv)[0] == '-')
	for (s = argv[0]+1; *s; s++)
		switch (*s) {
		case 's':
			sflg++;
			break;
		default:
			usage();
		}

  if (argc == 1) {
	if ((fd = open(argv[0], 0)) == -1)
		error("can't open %s", argv[0]);
  }
  else if (!isatty(0))
	fd = 0;

  if (fd == -1) {
	backgnd();
	rds();
  }
  else {
	if (read(fd, vram, sizeof(vram)) != sizeof(vram))
		error("This is not a RDS image file", (char *)0);
  }

  if (isatty(1))
	wrt_vram();
  else
	write(1, vram, sizeof(vram));

  exit(0);
}

void usage()
{
  fprintf(stderr, "Usage: %s [-s] [file]\n", cmd);
  exit(1);
}

void error(s, t) char *s, *t;
{
  fprintf(stderr, "%s: ", cmd);
  fprintf(stderr, s, t);
  fprintf(stderr, "\n");
  exit(1);
}

void backgnd()
{	/* create background random dot pattern */
  unsigned int c, k, x, y;
  long clock;

  time(&clock);
  srand((int)clock);
  for (y = 0; y < DOTY; y++)
	for (x = 0; x < PITCH; x++) {
		k = x / 8 + y * 80;
		if (sflg) {
			c = rand();
			vram[k] = (c >> 8) & rand() & 0xff;
		}
		else
			vram[k] = rand() & 0xff;
	}
}

void rds()
{	/* create a Random Dot Stereogram */
  static bit[] = { 128, 64, 32, 16, 8, 4, 2, 1 };
  unsigned int k;
  int r2, u, v, x, y, z, x0, y0, x1, x2, y1, y2;
  double a1, a2, sqrt();
  int b1, b2, c;

  /* center */
  x0 = (DOTX + PITCH) / 2;
  y0 = DOTY / 2;

  /* view port */
  x1 = x0 - RADIUS;
  x2 = x0 + RADIUS;
  y1 = DOTY / 2 - RADIUS;
  y2 = DOTY / 2 + RADIUS;

  /* circle parameter */
  r2 = RADIUS * RADIUS;

  /* triangle parameters */
  a1 = sqrt(3.0);
  a2 = -a1;
  b1 = (int)(a1 * -(double)x0) + RADIUS + y0;
  b2 = (int)(a2 * -(double)x0) + RADIUS + y0;
  c = y0 - RADIUS / 2;

  for (y = 0; y < DOTY; y++)
	for (x = PITCH; x < DOTX; x++) {
		z = x - PITCH;
		if (x < x1 || x2 < x || y < y1 || y2 < y)
			goto background;	/* fast check */
		u = x - x0; v = y - y0;
		if (u * u + v * v <= r2) {	/* circle */
			z += DEPTH;
			if (y >= c	/* triangle */
				&& y < (int)(a1 * (double)x) + b1
					&& y < (int)(a2 * (double)x) + b2)
				z += DEPTH;
		}
background:
		k = z / 8 + y * 80;
		if (vram[k] & bit[z % 8]) {
			k = x / 8 + y * 80;
			vram[k] |= bit[x % 8];
		}
	}
}

void
wrt_vram()
{
  static bit[] = { 128, 64, 32, 16, 8, 4, 2, 1 };
  int i, j;

  gopen(DOTX, DOTY);
  window(0.0, (double)DOTX, 0.0, (double)DOTY);
  for (i = 0; i < DOTY; i++)
	for (j = 0; j < DOTX; j++) {
		if (vram[i * (DOTX/8) + j / 8] & bit[j % 8])
			point((double)j, (double)i);
	}
  gclose();
}
