/*
 *  Sielpinski Curve
 *
 * Sielpinski׶ȸƤФ޷Ǥ
 */

#include <stdio.h>

void a(), b(), c(), d();

double h;

main(argc, argv) char **argv;
{
  int i;
  double x, y;

  gopen(500, 500);
  viewport(0.1, 0.9, 0.1, 0.9);
  h = 512.0;
  window(0.0, h, 0.0, h);
  gclear();
  h *= 0.25;
  x = 2.0 * h; y = 3.0 * h;
  for (i = 1; i < 5; i++) {
	x -= h;
	h *= 0.5;
	y += h;
	move(x, y);
	a(i); idraw(h, -h);
	b(i); idraw(-h, -h);
	c(i); idraw(-h, h);
	d(i); idraw(h, h);
  }
  gclose();
}

void
a(i)
{
  if (i-- > 0) {
	a(i); idraw(h, -h);
	b(i); idraw(2.0 * h, 0.0);
	d(i); idraw(h, h);
	a(i);
  }
}

void
b(i)
{
  if (i-- > 0) {
	b(i); idraw(-h, -h);
	c(i); idraw(0.0, -2.0 * h);
	a(i); idraw(h, -h);
	b(i);
  }
}

void
c(i)
{
  if (i-- > 0) {
	c(i); idraw(-h, h);
	d(i); idraw(-2.0 * h, 0.0);
	b(i); idraw(-h, -h);
	c(i);
  }
}

void
d(i)
{
  if (i-- > 0) {
	d(i); idraw(h, h);
	a(i); idraw(0.0, 2.0 * h);
	c(i); idraw(-h, h);
	d(i);
  }
}
