/*
 *  Tree
 *
 *  (C) 1988 K.Hirabayashi
 *
 *  ۥӡκʤǤ顢ͳˤȤ
 */

#include <stdio.h>
#include <stdlib.h>

#define PI 3.14159265

void tree();

main(argc, argv) char **argv;
{
  gopen(500, 500);
  viewport(0.1, 0.9, 0.1, 0.9);
  window(-2.0, 2.0, -1.0, 2.0);
  gclear();
  line(0.0, -1.0, 0.0, 0.0);
  tree(12, 0.0, 0.0, 1.0, PI / 2.0);
  gclose();
}

void
tree(i, u, v, w, t) double u, v, w, t;
{
  double x, y, z, d_rand(), sin(), cos();

//  kbhit();
  if (--i > 0) {
	x = u + w * 1.5 * cos(t);
	y = v + w * 1.5 * sin(t);
	line(u, v, x, y);
#if __TURBOC__
	w *= 0.6 + d_rand() * 0.3;
#else
	w *= 0.5 + d_rand() * 0.4;
#endif
	z = t + PI / 6.0;
	x = u + w * cos(z);
	y = v + w * sin(z);
	line(u, v, x, y);
	tree(i, x, y, w, z);
	z = t - PI / 6.0;
	x = u + w * cos(z);
	y = v + w * sin(z);
	line(u, v, x, y);
	tree(i, x, y, w, z);
  }
}

double
d_rand()
{
  double x;

  x = (double) rand() / (double)RAND_MAX;
  return x;
}
