/*
 *  Hilbert Curve
 *
 * Hilbert׶ȸƤФ޷Ǥ
 */

#include <stdio.h>

void a(), b(), c(), d();

double h;

main(argc, argv) char **argv;
{
  int i;
  double w, x, y;

  gopen(500, 500);
  viewport(0.1, 0.9, 0.1, 0.9);
  h = 512.0;
  window(0.0, h, 0.0, h);
  gclear();
  x = y = 0.5 * h;
  for (i = 1; i < 6; i++) {
	h *= 0.5;
	w = 0.5 * h;
	x += w; y += w;
	move(x, y);
	a(i);
  }
  gclose();
}

void
a(i)
{
  if (i-- > 0) {
	d(i); idraw(-h, 0.0);
	a(i); idraw(0.0, -h);
	a(i); idraw(h, 0.0);
	b(i);
  }
}

void
b(i)
{
  if (i-- > 0) {
	c(i); idraw(0.0, h);
	b(i); idraw(h, 0.0);
	b(i); idraw(0.0, -h);
	a(i);
  }
}

void
c(i)
{
  if (i-- > 0) {
	b(i); idraw(h, 0.0);
	c(i); idraw(0.0, h);
	c(i); idraw(-h, 0.0);
	d(i);
  }
}

void
d(i)
{
  if (i-- > 0) {
	a(i); idraw(0.0, -h);
	d(i); idraw(-h, 0.0);
	d(i); idraw(0.0, h);
	c(i);
  }
}
