/*
 *  Dragon curve
 *
 * Dragon׶ȸƤФΤǡơפޤǡ٤ƤγѤľѤˤʤ
 * 褦˹ȡζǤޤ򺹤뤳ȤϤޤ
 */

#include <stdio.h>

double h;

main(argc, argv) char **argv;
{
  void dragon();

  gopen(500, 500);
  viewport(0.1, 0.9, 0.1, 0.9);
  window(-10.0, 10.0, -10.0, 10.0);
  gclear();
  h = 0.5;
  move(-4.0, -6.5);
  dragon(10, h, 0.0);
  gclose();
}

void
dragon(i, u, v) double u, v;
{
  kbhit();
  if (--i < 0)
	idraw(u, v);
  else if (u > 0.0) {
	dragon(i, h, 0.0);
	dragon(i, 0.0, h);
  }
  else if (v > 0.0) {
	dragon(i, -h, 0.0);
	dragon(i, 0.0, h);
  }
  else if (u < 0.0) {
	dragon(i, -h, 0.0);
	dragon(i, 0.0, -h);
  }
  else {
	dragon(i, h, 0.0);
	dragon(i, 0.0, -h);
  }
}
